/// <reference types="react" />
import * as React from "react";
import { ITsRpcClient, TsRpcPtl } from "tsrpc-protocol";
import SuperPromise from "k8w-super-promise";
import FullTsApp from './FullTsApp';
import * as PropTypes from 'prop-types';
export default class FullTsComponent<P = {}, S = {}> extends React.Component<P, S> implements ITsRpcClient {
    static contextTypes: {
        fullTsApp: PropTypes.Requireable<any>;
    };
    constructor(props: P, context?: any);
    protected _apiRequests: {
        [sn: number]: SuperPromise<any>;
    };
    callApi<Req, Res>(ptl: TsRpcPtl<Req, Res>, req?: Req): SuperPromise<Res>;
    /**
     * Current FullTSApp Instance
     */
    readonly app: FullTsApp;
    private _componentWillUnmount();
    private _cancelAllApiRequest();
    private _setTimeoutTimers;
    /**
     * 同原生setTimeout 但uncomponent时会自动清除
     * @param handler
     * @param ms
     */
    setTimeout(handler: () => void, ms: number): number;
    private _setIntervalTimers;
    /**
     * 同原生setInterval 但uncomponent时会自动清除
     * @param handler
     * @param ms
     */
    setInterval(handler: () => void, ms: number): number;
    private _globalEventListeners;
    /**
     * 同xxx.addEventListener unmount时会自动removeEventListener
     * @param target
     * @param type
     * @param listener
     * @param options
     */
    addEventListener(target: EventTarget, type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;
}
